diff --git a/drivers/pnp/jazz16pnp.c b/drivers/pnp/jazz16pnp.c
index e665945..a7f173d 100644
--- a/drivers/pnp/jazz16pnp.c
+++ b/drivers/pnp/jazz16pnp.c
@@ -180,12 +180,18 @@ out_no_dev:
 	return -ENOMEM;
 };
 
-static struct pnp_port jazz16pnp_ports[2] __initdata = {
+static struct pnp_port jazz16pnp_ports[] __initdata = {
+	{ .min = 0x220, .max = 0x220, .align = 0, .size = 0x10 },
+	{ .min = 0x330, .max = 0x330, .align = 0, .size = 0x02 },
 	{ .min = 0x210, .max = 0x260, .align = 0x10, .size = 0x10 },
 	{ .min = 0x300, .max = 0x330, .align = 0x10, .size = 0x02 },
 };
 
-static struct pnp_irq jazz16pnp_irqs[2] __initdata = {
+static struct pnp_irq jazz16pnp_irqs[] __initdata = {
+	{ .map[0] = (1 << 5),
+	  .flags = IORESOURCE_IRQ_HIGHEDGE },
+	{ .map[0] = (1 << 9),
+	  .flags = IORESOURCE_IRQ_HIGHEDGE },
 	{ .map[0] = (1 << 3) | (1 << 5) | (1 << 7) |
 		    (1 << 9) | (1 << 10) | (1 << 15),
 	  .flags = IORESOURCE_IRQ_HIGHEDGE },
@@ -194,7 +200,9 @@ static struct pnp_irq jazz16pnp_irqs[2] 
 	  .flags = IORESOURCE_IRQ_HIGHEDGE },
 };
 
-static struct pnp_dma jazz16pnp_dmas[2] __initdata = {
+static struct pnp_dma jazz16pnp_dmas[] __initdata = {
+	{ .map = (1 << 1), .flags = IORESOURCE_DMA_8BIT, },
+	{ .map = (1 << 5), .flags = IORESOURCE_DMA_16BIT, },
 	{ .map = (1 << 1) | (1 << 3), .flags = IORESOURCE_DMA_8BIT, },
 	{ .map = (1 << 5) | (1 << 7), .flags = IORESOURCE_DMA_16BIT, },
 };
@@ -215,9 +223,14 @@ static int __init jazz16pnp_add_sb(void)
 				   jazz16pnp_dmas, 2))
 		goto out_no_sboption;
 	if (!jazz16pnp_easy_option(sbdev, PNP_RES_PRIORITY_ACCEPTABLE,
-				   jazz16pnp_ports, 2,
-				   jazz16pnp_irqs, 1,
-				   jazz16pnp_dmas, 2))
+				   &jazz16pnp_ports[2], 2,
+				   &jazz16pnp_irqs[2], 2,
+				   &jazz16pnp_dmas[2], 2))
+		goto out_no_sboption;
+	if (!jazz16pnp_easy_option(sbdev, PNP_RES_PRIORITY_ACCEPTABLE,
+				   &jazz16pnp_ports[2], 2,
+				   &jazz16pnp_irqs[2], 1,
+				   &jazz16pnp_dmas[2], 2))
 		goto out_no_sboption;
 	memcpy(sbid->id, "PNPb00f", PNP_ID_LEN);
 	pnp_add_id(sbid, sbdev);
